

local libTable = LibBuilder()
if not libTable then return end


local function classget(self, name)
	--	Always create a prototype. This simplifies things, and 
	--	may prove useful if we decide to change a static-only 
	--	class in one revision to support instances in the next.
	local class, prototype, instanceMetatable = {}, {}, {}
	
	class.prototype = prototype
	instanceMetatable.__index = prototype
	
	function class:New(...)
		local this = setmetatable({}, instanceMetatable)
		
		if not class.instances then
			class.instances = setmetatable({}, { __mode = 'k'} )
		end
		
		class.instances[this] = true
		
		if class.OnNew then
			class:OnNew(this, ...)
		end
		
		return this
	end
	
	self[name] = class
	return class
end

libTable.classes = setmetatable( {}, { __index = classget } )
